////////////////////////////////////////////////////////////////////
// 
// Copyright (C) Decision Computer International Co., Ltd 
//
// # Project Name: PCI 12-bit AD/DA Card VC++ 6.0 Sample (DII)
//
// # Used Library: Dynamic Industrial Interface (DII)
//
// # Designer:   Jason Hong         2004/06/18
//
////////////////////////////////////////////////////////////////////

// PCI_12_ADDADlg.cpp : implementation file
//

#include "stdafx.h"
#include "PCI_12_ADDA.h"
#include "PCI_12_ADDADlg.h"
#include "Dii.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPCI_12_ADDADlg dialog

CPCI_12_ADDADlg::CPCI_12_ADDADlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPCI_12_ADDADlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPCI_12_ADDADlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPCI_12_ADDADlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCI_12_ADDADlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	
	DDX_Control(pDX ,IDC_BUTTON5 , m_ErrorNo );
	DDX_Control(pDX ,IDC_BUTTON4 , m_Outp );
	DDX_Control(pDX ,IDC_BUTTON3 , m_Inp );
	DDX_Control(pDX ,IDC_BUTTON2 , msg1 );
	DDX_Control(pDX, IDC_BUTTON1, m_Start_ADDA);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPCI_12_ADDADlg, CDialog)
	//{{AFX_MSG_MAP(CPCI_12_ADDADlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, ADDATest)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_CHECK1,IDC_CHECK16,DioTest)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCI_12_ADDADlg message handlers

BOOL CPCI_12_ADDADlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	BOOL init;
	BOOL temp;
	char DevName[200];
	CString str; 
	unsigned short preValue;

	init = DiiSelectDevice(NULL ,DevName ,210);

	if ( init == false)
		msg1.SetWindowText("Can't find the port!");

	hDevice = DiiOpenNamedDevice(DevName , true);

	if ( hDevice != INVALID_HANDLE_VALUE)
	{	
		msg1.SetWindowText ("Get card address success !!");
		temp = DiiGetDigitalWord( hDevice , 0 , &preValue );
		temp = DiiSetDigitalWord( hDevice , 0 , preValue );
		dioState = preValue;




		for (int i=0 ; i <16 ; i++) 
		{	
			if(preValue%2==1)
				CheckDlgButton (IDC_CHECK1+i,true);
            
			preValue = preValue / 2;
        }
	}
	else
	{
		msg1.SetWindowText( "Get card address fail !!");
		m_Start_ADDA.EnableWindow(false);
		
		for (int j=0 ; j <16 ; j++) 
		{	
			CheckDlgButton (IDC_CHECK1+j,true);
           
        }
			
	
	}
	
	m_bStartADDA = false;


	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPCI_12_ADDADlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CPCI_12_ADDADlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CPCI_12_ADDADlg::DioTest(UINT idCheck)
{
	int dwbit = idCheck - IDC_CHECK1;
	BOOL temp;
	BOOL state = IsDlgButtonChecked(idCheck);
	CString str;
	
	
	unsigned short s = 1;
	
//	str.Format ("%d",dwbit);
//	msg1.SetWindowText(str);
	
	for( int x = 0 ; x < dwbit; x++) 
		s = s * 2;


//	dioState = io;
	

	if(state) dioState += s;
	else dioState -= s;

	str.Format ("%d" , dioState);
//	msg1.SetWindowText(str);
	
	temp = DiiSetDigitalWord( hDevice , 0 , dioState );


}

void CPCI_12_ADDADlg::OnOK()
{
	KillTimer(m_nTimer);   
    
	CDialog::OnOK();

}



void CPCI_12_ADDADlg::ADDATest()
{

	m_bStartADDA = ~m_bStartADDA;

	if(m_bStartADDA)
	{
		m_Start_ADDA.EnableWindow(false);
		DA_Value=4095;

		m_nTimer = SetTimer (1 , 10, 0);
	
	}

}

void CPCI_12_ADDADlg::OnTimer(UINT nIDEvent) 
{
	



	// TODO: Add your message handler code here and/or call default
	
	DWORD ad;
	int ch;
	BOOL temp;
	CString str;
	int error; 

	ch =0;
	temp = DiiSetDigitalWord ( hDevice , ch, 0 );

	temp = DiiSetAnalogChannel(hDevice, 0, DA_Value);
	temp = DiiGetAnalogChannel(hDevice, 0, &ad);
	
//	temp = DiiSetDigitalWord( hDevice , 0 , ad );


	error = DA_Value - ad ;

	if ( error < 0 )
		error = -error;

	str.Format ("%d" , DA_Value);
	m_Inp.SetWindowText(str);
		
		
	str.Format ("%d" , ad);
	m_Outp.SetWindowText(str);

	
	str.Format ("%d" , error);
	m_ErrorNo.SetWindowText(str);


	DA_Value  = DA_Value - 5;
	

	
		
	if(DA_Value < 5)	// complete execution , resume previous state
	{
		KillTimer(m_nTimer);   		
		m_Start_ADDA.EnableWindow(true);

		temp = DiiSetDigitalWord( hDevice , 0 , dioState );
		m_bStartADDA = ~m_bStartADDA;
	}

	CDialog::OnTimer(nIDEvent);
}
